import { IApp } from "./IApp";
import { ILogger } from "./ILogger";
export declare abstract class AppTemplateBase<T> implements IApp<T> {
    logger: ILogger;
    ioc: T;
    abstract createIoc(): T;
    abstract createLogger(): ILogger;
    constructor();
    abstract initContainer(): Promise<void>;
    abstract init(): Promise<void>;
    abstract register(ioc: T): Promise<void>;
    abstract resolve(ioc: T): Promise<void>;
    abstract main(): Promise<void>;
    abstract exit(): Promise<void>;
    execute(): Promise<void>;
}
