/*
 * Plugin Metadata API
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// PluginMetadata
    /// </summary>
    [DataContract(Name = "PluginMetadata")]
    public partial class PluginMetadata : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PluginMetadata" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PluginMetadata() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PluginMetadata" /> class.
        /// </summary>
        /// <param name="nameTag">Unique identifier for the plugin (required).</param>
        /// <param name="varVersion">Version of the plugin, following semantic versioning (required).</param>
        /// <param name="executableFile">Path to the main executable file for the plugin (required).</param>
        /// <param name="author">author (required).</param>
        /// <param name="inputs">Input validation schema for the plugin (required).</param>
        /// <param name="outputs">Output structure for the plugin.</param>
        /// <param name="description">Brief description of the plugin&#39;s functionality (required).</param>
        public PluginMetadata(string nameTag = default(string), string varVersion = default(string), string executableFile = default(string), PluginMetadataAuthor author = default(PluginMetadataAuthor), Dictionary<string, Object> inputs = default(Dictionary<string, Object>), Dictionary<string, Object> outputs = default(Dictionary<string, Object>), string description = default(string))
        {
            // to ensure "nameTag" is required (not null)
            if (nameTag == null)
            {
                throw new ArgumentNullException("nameTag is a required property for PluginMetadata and cannot be null");
            }
            this.NameTag = nameTag;
            // to ensure "varVersion" is required (not null)
            if (varVersion == null)
            {
                throw new ArgumentNullException("varVersion is a required property for PluginMetadata and cannot be null");
            }
            this.VarVersion = varVersion;
            // to ensure "executableFile" is required (not null)
            if (executableFile == null)
            {
                throw new ArgumentNullException("executableFile is a required property for PluginMetadata and cannot be null");
            }
            this.ExecutableFile = executableFile;
            // to ensure "author" is required (not null)
            if (author == null)
            {
                throw new ArgumentNullException("author is a required property for PluginMetadata and cannot be null");
            }
            this.Author = author;
            // to ensure "inputs" is required (not null)
            if (inputs == null)
            {
                throw new ArgumentNullException("inputs is a required property for PluginMetadata and cannot be null");
            }
            this.Inputs = inputs;
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new ArgumentNullException("description is a required property for PluginMetadata and cannot be null");
            }
            this.Description = description;
            this.Outputs = outputs;
        }

        /// <summary>
        /// Unique identifier for the plugin
        /// </summary>
        /// <value>Unique identifier for the plugin</value>
        [DataMember(Name = "nameTag", IsRequired = true, EmitDefaultValue = true)]
        public string NameTag { get; set; }

        /// <summary>
        /// Version of the plugin, following semantic versioning
        /// </summary>
        /// <value>Version of the plugin, following semantic versioning</value>
        [DataMember(Name = "version", IsRequired = true, EmitDefaultValue = true)]
        public string VarVersion { get; set; }

        /// <summary>
        /// Path to the main executable file for the plugin
        /// </summary>
        /// <value>Path to the main executable file for the plugin</value>
        [DataMember(Name = "executableFile", IsRequired = true, EmitDefaultValue = true)]
        public string ExecutableFile { get; set; }

        /// <summary>
        /// Gets or Sets Author
        /// </summary>
        [DataMember(Name = "author", IsRequired = true, EmitDefaultValue = true)]
        public PluginMetadataAuthor Author { get; set; }

        /// <summary>
        /// Input validation schema for the plugin
        /// </summary>
        /// <value>Input validation schema for the plugin</value>
        [DataMember(Name = "inputs", IsRequired = true, EmitDefaultValue = true)]
        public Dictionary<string, Object> Inputs { get; set; }

        /// <summary>
        /// Output structure for the plugin
        /// </summary>
        /// <value>Output structure for the plugin</value>
        [DataMember(Name = "outputs", EmitDefaultValue = false)]
        public Dictionary<string, Object> Outputs { get; set; }

        /// <summary>
        /// Brief description of the plugin&#39;s functionality
        /// </summary>
        /// <value>Brief description of the plugin&#39;s functionality</value>
        [DataMember(Name = "description", IsRequired = true, EmitDefaultValue = true)]
        public string Description { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class PluginMetadata {\n");
            sb.Append("  NameTag: ").Append(NameTag).Append("\n");
            sb.Append("  VarVersion: ").Append(VarVersion).Append("\n");
            sb.Append("  ExecutableFile: ").Append(ExecutableFile).Append("\n");
            sb.Append("  Author: ").Append(Author).Append("\n");
            sb.Append("  Inputs: ").Append(Inputs).Append("\n");
            sb.Append("  Outputs: ").Append(Outputs).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
